#pragma once

#include <Core/Message/Filter.h>

#include <functional>

#include "MessageBroker.h"

class Subscription
{
public:
    void unsubscribe() { MessageBroker::getInstance().unsubscribe(this); }

    bool matchesFilter(Filter filter) { return this->filter == filter; }

    ~Subscription() { unsubscribe(); }

    friend class MessageBroker;

private:
    Subscription(MessageBroker::SubscriberFn callback, Filter filter)
        : filter(filter), callback(std::move(callback))
    {
    }

    Subscription()                     = delete;
    Subscription(Subscription&)        = delete;
    Subscription(Subscription&& other) = delete;

    Filter filter;
    MessageBroker::SubscriberFn callback;
};