/*
 * This file is part of Skyward Hub.
 *
 * Skyward Hub is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 *
 * Skyward Hub is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * Skyward Hub. If not, see <https://www.gnu.org/licenses/>.
 *
 */

#pragma once

#include <Core/MessageBroker/Subscription.h>
#include <Modules/Module.h>

#include <QWidget>

namespace Ui
{
class TestModule;
}

class TestModule : public Module
{
    Q_OBJECT

public:
    TestModule();
    ~TestModule();

private slots:
    void on_publish_button_clicked();

    void on_subscribe_button_clicked();

    void on_unsubscribe_button_clicked();
    void onMaxCharChanged(int value);

private:
    Ui::TestModule *ui;

    int maxChar = 2000;

    std::shared_ptr<Subscription> subscription;
};
